# IO Engage Integration

## What is it?

Basic implementation for keeping delegate records up to date with IO Engage and update meeting attendance 

## How does it work

Intended implemenation is for one line usage through a facade accessor.

Updating meeting attendance is handled via queued jobs as we cannot make batch requests through to the IOEngage API meaning every delegate associated to an event will require an update individually should event information change.

## Configuration

You will need to publish the ioengage config through the vendor:publish command. All publishable items are tagged with `ioengage-integration`

### Environment Keys
```
IOENGAGE_CLIENT_ID=CLIENT_ID
IOENGAGE_CLIENT_SECRET=CLIENT_SECRET 
# This shouldn't need to be changed but it's configurable just in case
IOENGAGE_GRANT_TYPE=CLIENT_CREDENTIALS

IOENGAGE_TOKEN_ENDPOINT=https://example.com/token
IOENGAGE_DELEGATE_ENDPOINT=https://example.com/delegate
IOENGAGE_SEARCH_ENDPOINT=https://example.com/search
IOENGAGE_MEETING_ENDPOINT=https://example.com/meeting
```

## Usage

### Search
```php
// See below for a full list of searchable properties
$parameters = ['FirstName' => 'Kevin', 'City' => 'Scranton'];

$results = IOEngage::search($parameters)
```

#### Parameters
* `Address` - Address Object **(CURRENTLY NOT WORKING)**
* `Company` - String
* `Country` - String
* `County` - String
* `Email` - String
* `FirstName` - 'LIKE' search only
* `JobTitle` - String
* `KeyContact` - Boolean **(NOT WORKING)**
* `LastName` - 'LIKE' search only
* `Name` - **(NOT WORKING?)**
* `Page` - Default: 1 **(NOT WORKING, offsets based on the PerPage)**
* `PerPage` - Default: 10 **(CURRENTLY NOT WORKING)**
* `Postcode`
* `Region`

### Get Delegates by One Key ID
```php
// To get a single delegate
$result = IOEngage::delegates('VALIDONEKEYID');

// To get multiple delegates
$results = IOEngage::delegate('ONEKEYID', 'TWOKEYID');

// To get all delegates belonging to an event
$results = IOEngage::delegate($event->delegates->pluck('identifier'));

```

### Update Meeting Attendance
```php
IOEngage::updateEventDelegate($event, $delegate);
```
