<?php

namespace Drp\IOEngage\Jobs;

use Drp\IOEngage\IOEngage;
use Drp\IOEngage\Transformers\EventDelegateTransformer;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class UpdateEventDelegateStatus implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * @var IOEngage
     */
    private $client;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct(array $event, array ...$delegates)
    {
        $this->event = $event;
        $this->delegates = $delegates;
        $this->client = new IOEngage();
    }

    /**
     * Execute the job.
     */
    public function handle(): void
    {
        // we will have a list of delegates (20 MAX) and an event.
        $this->client->meetingUpdate(
            EventDelegateTransformer::transform($this->event, $this->delegates)
        );
    }
}
