<?php

namespace Drp\IOEngage\Responses;

use Drp\IOEngage\Exceptions\DelegateRetrievalFailed;
use Illuminate\Support\Collection;

class DelegateResponse extends Response
{
    /** @var array<string> */
    protected $fields = [
        'ValidRecordCount',
        'ValidResults',
        'InvalidRecordCount',
        'InvalidResults',
    ];

    /** @var string */
    protected $exception = DelegateRetrievalFailed::class;

    public function delegates(): Collection
    {
        return collect($this->ValidResults);
    }

    public function failed(): ?Collection
    {
        return $this->InvalidRecordCount > 0 ? collect($this->InvalidResults) : null;
    }
}
