<?php

namespace Drp\IOEngage\Responses;

use Error;
use Illuminate\Support\Arr;

class Response
{
    /**
     * Required fields that must be in the response payload
     *
     * @var array
     */
    protected $fields = [];

    /**
     * The data from the payload
     *
     * @var array
     */
    protected $data = [];

    /**
     * The validation exception that will be thrown if it fails
     *
     * @var string
     */
    protected $exception = Error::class;

    public function __construct(array $data)
    {
        $this->validate($data);
        $this->data = $data;
    }

    private function validate(array $data): void
    {
        if (count($this->fields) <=0) {
            return;
        }

        throw_unless(
            Arr::has($data, $this->fields),
            new $this->exception('Payload Validation Failed')
        );
    }

    /**
     * @return mixed
     */
    public function __get(string $name)
    {
        return Arr::get($this->data, $name);
    }
}
