<?php

namespace Drp\IOEngage\Responses;

use Drp\IOEngage\Exceptions\SearchFailed;
use Illuminate\Support\Collection;

class SearchResponse extends Response
{
    /** @var array<string> */
    protected $fields = [
        'PerPage',
        'CurrentPage',
        'TotalPages',
        'TotalResults',
        'RecordCount',
        'Results',
    ];

    /** @var string */
    protected $exception = SearchFailed::class;

    public function delegates(): Collection
    {
        return collect($this->Results);
    }

    public function page(): array
    {
        return [
            'current' => $this->CurrentPage,
            'total' => $this->TotalPages,
        ];
    }
}
